-------------------------------------------------
-- global vars
-------------------------------------------------

Equi_Notepad_PLAYERNAME = "";			-- current players name
Equi_Notepad_IGNORE_UPDATE = false;		-- used to prevent scroll bar updating when editbox text is set


-------------------------------------------------
-- event functions
-------------------------------------------------
function Equi_NotepadButton_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		Equi_Notepad_PLAYERNAME = UnitName("player");

		EQUI_SHARED_TEXT = tostring(EQUI_SHARED_TEXT);
		if EQUI_SHARED_TEXT == "nil" then
			EQUI_SHARED_TEXT = "";
		end
		
		EQUI_CHAR_TEXT = tostring(EQUI_CHAR_TEXT);
		if EQUI_CHAR_TEXT == "nil" then
			EQUI_CHAR_TEXT = "";
		end
		
		Equi_NotepadUpdatePage();
		Equi_NotepadSetText();
		
    elseif event == "PLAYER_LEAVING_WORLD" then
       Equi_NotepadStoreText(false);
    end
end

function Equi_NotepadButton_OnClick()
	Equi_NotepadToggleView();
end

function Equi_NotepadUpdateScroller()
	-- return true if scroll can be updated, otherwise it clears flag
	if (Equi_Notepad_IGNORE_UPDATE) then
		Equi_Notepad_IGNORE_UPDATE = false;
		return false;
	else
		return true;
	end
end

function Equi_NotepadSetFocus()
	if EQUI_USE_SHARED then
		Equi_NotepadTextAreaSEditBox:SetFocus();
	else
		Equi_NotepadTextAreaCEditBox:SetFocus();
	end
end


-------------------------------------------------
-- button triggered actions
-------------------------------------------------

function Equi_NotepadToggleView()
	if(Equi_NotepadForm:IsVisible()) then
		Equi_NotepadSave();
	else
		Equi_NotepadUpdatePage();
		Equi_NotepadForm:Show();
		Equi_NotepadSetFocus();
	end
end

function Equi_NotepadTogglePage()
	-- toggle
	if EQUI_USE_SHARED then
		EQUI_USE_SHARED = false;
	else
		EQUI_USE_SHARED = true;
	end
	
	PlaySound("igQuestListOpen");
	
	-- show page content
	Equi_NotepadUpdatePage();
	Equi_NotepadSetFocus();
end

function Equi_NotepadSave()
	-- save text and hide window
	Equi_NotepadStoreText(true);
	Equi_NotepadForm:Hide();
end

function Equi_NotepadCancel()
	-- revert to previous text and hide window
	Equi_NotepadSetText();
	Equi_NotepadForm:Hide();
end


-------------------------------------------------
-- text functions
-------------------------------------------------

function Equi_NotepadUpdatePage()
	-- set current page name & contents
	if EQUI_USE_SHARED then
		Equi_NotepadPageName:SetText("Page: Shared notes");
		Equi_NotepadTextAreaS:Show()
		Equi_NotepadTextAreaC:Hide()
	else
		Equi_NotepadPageName:SetText("Page: " .. Equi_Notepad_PLAYERNAME .. "'s notes");
		Equi_NotepadTextAreaC:Show()
		Equi_NotepadTextAreaS:Hide()
	end
end

function Equi_NotepadSetText()
	-- set editbox text from saved vars
	Equi_NotepadTextAreaSEditBox:SetText(EQUI_SHARED_TEXT);
	Equi_NotepadTextAreaCEditBox:SetText(EQUI_CHAR_TEXT);
	
	Equi_Notepad_IGNORE_UPDATE = true;		-- do not update scroller
end

function Equi_NotepadStoreText(playSoundFx)
	-- save text to stored var
	EQUI_SHARED_TEXT = Equi_NotepadTextAreaSEditBox:GetText();
	EQUI_CHAR_TEXT = Equi_NotepadTextAreaCEditBox:GetText();
	
	if playSoundFx then
		PlaySound("WriteQuest");
	end
end
